
#include "AI.h"

AI::AI(const orxCHAR* key, bool onLeft){
	this->ballPreviousPos = orxVECTOR_0;
        this->left = onLeft;
	Init(key);
}

AI::~AI(){
}

orxSTATUS AI::Init(const orxCHAR* key){
	this->oPaddleObject = orxObject_CreateFromConfig(key);
	if(this->oPaddleObject == orxNULL){
		orxLOG("Init()-<%s> nenalezen!", key);
		return orxSTATUS_FAILURE;
	}

	orxConfig_PushSection(key);
                this->iSide = static_cast<int>(orxConfig_GetFloat("Orientation"));
		this->fMaxSpeed = orxConfig_GetFloat("MaximalSpeed");
		this->iRadius = static_cast<int>(320*iSide);
	orxConfig_PopSection();

        if(iSide == -1)
                this->vBonusPos.fX = -507.f;
        else
                this->vBonusPos.fX = 429.f;
        
	this->vBonusPos.fY = -115.f;
        
	orxSpawner_Enable(orxOBJECT_GET_STRUCTURE(oPaddleObject, SPAWNER), false);

	this->sName = orxObject_GetName(this->oPaddleObject);
        
        this->bHuman = false;
        
	return orxSTATUS_SUCCESS;
}

int AI::Update(Ball* _Ball){
	_Ball->CalculateIntersection();
	float lifetime = orxObject_GetLifeTime(oPaddleObject);
	if(lifetime < 1.0f && lifetime > 0.f){
		return 1; //return OBJECT_STATUS::DEATH
	}

        bool activation = false;
	int directionLeft = _Ball->GetDirection();
	orxVECTOR intersection = _Ball->GetIntersection();
	float intersectionY = intersection.fY;
        
        if(iBonus != 9 && iBonusActivated == 9) //cast container isnt empty and there isnt any activated bonus
            activation = true;  //it is possible to activate bonus

	switch(directionLeft){
	//left
	case 1:
                if(left){
                    if(intersectionY > this->vPaddlePos.fY)
                            this->iDirection = -1; //tak dolu
                    else if(intersectionY < this->vPaddlePos.fY)
                            this->iDirection = 1; //tak nahoru
                }else{
                    SetDirection(0);
                }
		break;
	//right
	case 0:
                if(!left){
                    if(intersectionY > vPaddlePos.fY)
                            SetDirection(1); //down
                    else if(intersectionY < this->vPaddlePos.fY)
                            SetDirection(-1); //up
                    
                    if(activation && (iBonus == 5 || iBonus == 6)){      //MAGNETIC_PADDLE || MEGA_STROKE
                        return 3; //ACTIVATE_BONUS
                    }
                }else{
                    SetDirection(0);
                }
		break;
	
	default:
		SetDirection(0);
		break;
	};

        if(activation){
            if(iBonus == 3 || iBonus == 7)
                return 3;       //ACTIVATE_BONUS
            if(iBonus == 0 && (_Ball->GetSpeed().fX > 300.f || _Ball->GetSpeed().fY > 300.f))
                return 3;       //ACTIVATE_BONUS   
        }
        
	if(vPaddlePos.fY < intersectionY+10 && vPaddlePos.fY > intersectionY-10)
		SetDirection(0);

	return 2; //return OBJECT_STATUS::NOTHING
}

