#ifndef _BALL_H
#define _BALL_H

#include "orx.h"
#include <string>

#include "Tools.h"

#define MEGA_POWER 300.f
#define HIGH_POWER 40.f

class Ball{
private:
	orxOBJECT*	oBallObject;			

	orxVECTOR	vPreviousPos;			
	orxVECTOR	vPos;				

	orxVECTOR	vVelocityConstant;	

	orxVECTOR	vIntersectionPoint;		

	int		iBallDirection;		
        int             iLastTouch;

	float		fHorizontal;	
	float		fVertical;
        
        bool            bMegaStroke;

	const orxCHAR* sName;				

	/*Private function*/
	float		DistFromOrigin(float x, float y);
public:
	Ball(const orxCHAR* key);
	~Ball();

	orxSTATUS		Init(const orxCHAR* key);
        
	void			CalculateIntersection();
	int			Update();

	void			Reload();
	void			Enable();
	void			Disable();

	void                    NormalMotion();

	void                    SlowMotion();
        void                    IncreaseSpeed(float power = 0.f);
        void                    DecreaseSpeed();
        void                    MegaStroke(bool enable);

	void			SetSpeed(float sx, float sy); 
	void			SetPosition(float px, float py);
	void			SetPreviousPos(float px, float py);
	void                    SetIntersection(float ix, float iy);
        void                    SetLastTouch(int object){ iLastTouch = object;};

	orxOBJECT*		GetBall(){ return oBallObject;};
	const orxVECTOR		GetSpeed();
	const orxVECTOR		GetPosition(){ return *(orxObject_GetPosition(oBallObject, &vPos));};
	const orxVECTOR		GetPreviousPos(){ return vPreviousPos;};
        const orxVECTOR		GetVelocityConst(){ return vVelocityConstant;};
	const orxVECTOR		GetIntersection();
        const int               GetLastTouch(){ return iLastTouch;};
	const int		GetDirection(){ return iBallDirection;};
	const std::string	GetName();
};
#endif