
#include "Control.h"

orxCLOCK* Control::bonusClk = orxNULL;
std::map<BONUS, orxOBJECT*> Control::bonuses;

Control::Control(){
	this->pstPlayerLeftStatus = NOTHING;
	this->pstPlayerRightStatus = NOTHING;
	this->pstBallStatus = NOTHING;
	this->bGameWinner = 0; //jestli jeden z hracu ma vic jak 5 bodu promenna se nastavi na na 1 nebo -1
        this->bonusTimerActive = false;
        this->automaticBonusActivation = false;
        
        this->pstPlayerLeft = NULL;
        this->pstPlayerRight = NULL;
        this->pstBall = NULL;
        this->pstBonusBar1 = NULL;
        this->pstBonusBar2 = NULL;
        this->pstPointBar1 = NULL;
        this->pstPointBar2 = NULL;
        this->pstBorderLeft = NULL;
        this->pstBorderRight = NULL;
        this->pstCastLContainer = orxNULL;
        this->pstCastRContainer = orxNULL;
        
        orxMath_InitRandom(698543658);
}

Control::~Control(){
	if(pstPlayerLeft != NULL){
		delete pstPlayerLeft;
		pstPlayerLeft = NULL;
	}
	if(pstPlayerRight != NULL){
		delete pstPlayerRight;
		pstPlayerRight = NULL;
	}
	if(pstBall != NULL){
		delete pstBall;
		pstBall = NULL;
	}
        if(pstBorderLeft != NULL){
            delete pstBorderLeft;
            pstBorderLeft = NULL;
        }
        if(pstBorderRight != NULL){
            delete pstBorderRight;
            pstBorderRight = NULL;
        }
        if(pstBonusBar1 != NULL){
            delete pstBonusBar1;
            pstBonusBar1 = NULL;
        }
        if(pstBonusBar2 != NULL){
            delete pstBonusBar2;
            pstBonusBar2 = NULL;
        }
        if(pstPointBar1 != NULL){
            delete pstPointBar1;
            pstPointBar1 = NULL;
        }
        if(pstPointBar2 != NULL){
            delete pstPointBar2;
            pstPointBar2 = NULL;
        }
        if(pstCastLContainer != orxNULL){
            orxObject_SetLifeTime(pstCastLContainer, orxFLOAT_0);
            pstCastLContainer = orxNULL;
        }
        if(pstCastRContainer != orxNULL){
            orxObject_SetLifeTime(pstCastRContainer, orxFLOAT_0);
            pstCastRContainer = orxNULL;
        }
        if(bonusClk != orxNULL){
            orxClock_Unregister(bonusClk, CreateBonus);
            orxClock_Delete(bonusClk);
            bonusClk = orxNULL;
        } 
        
        /*std::map<BONUS, orxOBJECT*>::const_iterator it = bonuses.begin();
        for( ; it != bonuses.end(); ++it){
            if((*it).second != orxNULL){
                orxOBJECT *object = (*it).second;
                orxObject_SetLifeTime(object, orxFLOAT_0);
                //it->second = orxNULL;
            }
        }*/
}

orxSTATUS Control::CreateSingleGame(){
	orxSTATUS eResult;

	//Vytvoreni hracu
	eResult = orxInput_SelectSet("SinglePlayerInput");
	pstBall =  new Ball("BallParticle");
	pstPlayerLeft = new Player("Player1Paddle");
	pstPlayerRight = new AI("AI1Paddle", false);

	pstBorderLeft = new Border("BorderLeft");
        pstBorderRight = new Border("BorderRight");
        bonusClk = orxClock_CreateFromConfig("BonusClock");
        
        CreateUI();
        
        orxClock_Register(bonusClk, CreateBonus, orxNULL, orxMODULE_ID_CLOCK, orxCLOCK_PRIORITY_NORMAL);
	return eResult;
}

orxSTATUS Control::CreateMultiGame(){
	orxSTATUS eResult;

	//Vytvoreni hracu
	eResult = orxInput_SelectSet("MultiPlayerInput");
	pstBall =  new Ball("BallParticle");
	pstPlayerLeft = new Player("Player1Paddle");
	pstPlayerRight = new Player("Player2Paddle");

	pstBorderLeft = new Border("BorderLeft");
        pstBorderRight = new Border("BorderRight");
        bonusClk = orxClock_CreateFromConfig("BonusClock");
        
        CreateUI();
        
        orxClock_Register(bonusClk, CreateBonus, orxNULL, orxMODULE_ID_CLOCK, orxCLOCK_PRIORITY_NORMAL);

	return eResult;
}

orxSTATUS Control::CreateAIGame(){
	orxSTATUS eResult = orxSTATUS_SUCCESS;

	//Vytvoreni hracu
	pstBall =  new Ball("BallParticle");
	pstPlayerLeft = new AI("AI2Paddle", true);
	pstPlayerRight = new AI("AI1Paddle", false);

	pstBorderLeft = new Border("BorderLeft");
        pstBorderRight = new Border("BorderRight");
        bonusClk = orxClock_CreateFromConfig("BonusClock");
           
        CreateUI();
        
        orxClock_Register(bonusClk, CreateBonus, orxNULL, orxMODULE_ID_CLOCK, orxCLOCK_PRIORITY_NORMAL);

	return eResult;
}

void Control::CreateUI(){
    orxCOLOR color;
     //bonus timeline
    orxOBJECT* barBG1 = orxObject_CreateFromConfig("BonusBarBg");
    orxColor_SetRGBA(&color, orx2RGBA(0xFF, 0x54, 0x48, 0xFF));
    orxObject_SetColor(barBG1, &color);
    
    orxOBJECT* barBG2 = orxObject_CreateFromConfig("BonusBarBg");
    orxColor_SetRGBA(&color, orx2RGBA(0xFF, 0xE2, 0x51, 0xFF));
    orxObject_SetColor(barBG2, &color);
    
    //position and color
    orxVECTOR pos_bg, pos_line;
    orxVector_Set(&pos_bg, -512.f, -305.f, 0.f);
    orxVector_Set(&pos_line, -505.f, -290.f, 0.1f);    
    orxColor_SetRGBA(&color, orx2RGBA(0xFF, 0xFF, 0xFF, 0x32));
    
    //create bars
    pstBonusBar1 = new TimeBar(pos_bg, pos_line, color, barBG1, 197.f, 105.f, 10.f, false);
    orxVector_Set(&pos_bg, 302.f, -305.f, 0.f);
    orxVector_Set(&pos_line, 307.f, -290.f, 0.1f);
    pstBonusBar2 = new TimeBar(pos_bg, pos_line, color, barBG2, 197.f, 105.f, 10.f, false);

    //bonus cast container
    pstCastLContainer = orxObject_CreateFromConfig("BonusContainer"); 
    orxColor_SetRGBA(&color, orx2RGBA(0xFF, 0x54, 0x48, 0xFF));
    orxObject_SetColor(pstCastLContainer, &color);
    
    pstCastRContainer = orxObject_CreateFromConfig("BonusContainer");
    orxColor_SetRGBA(&color, orx2RGBA(0xFF, 0xE2, 0x51, 0xFF));
    orxObject_SetColor(pstCastRContainer, &color);
    
    orxVector_Set(&pos_bg, -512.f, -105.f, 0.f);    //left
    orxObject_SetPosition(pstCastLContainer, &pos_bg);
    orxVector_Set(&pos_bg, 424.f, -105.f, 0.f);    //right
    orxObject_SetPosition(pstCastRContainer, &pos_bg);

    orxConfig_PushSection("Players");
            int lifes = static_cast<int>(orxConfig_GetFloat("Lifes"));
    orxConfig_PopSection();

    //point bar
    orxOBJECT* pointBG1 = orxObject_CreateFromConfig("PointBarBg");
    orxColor_SetRGBA(&color, orx2RGBA(0xFF, 0x54, 0x48, 0xFF));
    orxObject_SetColor(pointBG1, &color);
    
    orxOBJECT* pointBG2 = orxObject_CreateFromConfig("PointBarBg");
    orxColor_SetRGBA(&color, orx2RGBA(0xFF, 0xE2, 0x51, 0xFF));
    orxObject_SetColor(pointBG2, &color);
    
    orxVector_Set(&pos_bg, -500.f, 350.f, 0.f);
    orxVector_Set(&pos_line, -495.f, 365.f, 0.1f);
    orxColor_SetRGBA(&color, orx2RGBA(0xFF, 0x0, 0x0, 0xFF));
    pstPointBar1 = new TimeBar(pos_bg, pos_line, color, pointBG1, 310.f, 20.f, lifes);
    orxVector_Set(&pos_bg, 186.f, 350.f, 0.f);
    orxVector_Set(&pos_line, 191.f, 365.f, 0.1f);
    pstPointBar2 = new TimeBar(pos_bg, pos_line, color, pointBG2, 310.f, 20.f, lifes);
}

void Control::UpdateSingleInput(){
	if(orxInput_IsActive("MoveUp")){
		pstPlayerLeft->SetDirection(1);
	}else if(orxInput_IsActive("MoveDown")){
		pstPlayerLeft->SetDirection(-1);
	}else{
		pstPlayerLeft->SetDirection(0);
	}

	if(orxInput_IsActive("TriggerBonus") && orxInput_HasNewStatus("TriggerBonus")){
            //if bonus is negative you cant turn it off
            if(pstPlayerLeft->IsBonusNegative() != true){
                //if you have some bonus activated, turn it off
                if((BONUS)pstPlayerLeft->GetActivatedBonus() != BONUS_NONE){
                    DeactivateBonus((BONUS)pstPlayerLeft->GetActivatedBonus(), PLAYER_LEFT);
                    pstPlayerLeft->BonusNone();
                    pstBonusBar1->SetFill(100);
                }
                
                //activate bonus in cast container
                ActivateBonus((BONUS)pstPlayerLeft->ActivateBonus(), PLAYER_LEFT);  
            }
	}
}

void Control::UpdateMultiInput(){
	//player 1
	if(orxInput_IsActive("Player1Up")){
		pstPlayerLeft->SetDirection(1);
	}else if(orxInput_IsActive("Player1Down")){
		pstPlayerLeft->SetDirection(-1);
	}else{
		pstPlayerLeft->SetDirection(0);
	}

	if(orxInput_IsActive("P1TriggerBonus") && orxInput_HasNewStatus("P1TriggerBonus")){
            if(pstPlayerLeft->IsBonusNegative() != true){
                if((BONUS)pstPlayerLeft->GetActivatedBonus() != BONUS_NONE){
                    DeactivateBonus((BONUS)pstPlayerLeft->GetActivatedBonus(), PLAYER_LEFT);
                    pstPlayerLeft->BonusNone();
                    pstBonusBar1->SetFill(100);
                }

                ActivateBonus((BONUS)pstPlayerLeft->ActivateBonus(), PLAYER_LEFT);  
            }
	}

	//player 2
	if(orxInput_IsActive("Player2Up")){
		pstPlayerRight->SetDirection(-1);
	}else if(orxInput_IsActive("Player2Down")){
		pstPlayerRight->SetDirection(1);
	}else{
		pstPlayerRight->SetDirection(0);
	}

	if(orxInput_IsActive("P2TriggerBonus") && orxInput_HasNewStatus("P2TriggerBonus")){
            if(pstPlayerRight->IsBonusNegative() != true){
                if((BONUS)pstPlayerRight->GetActivatedBonus() != BONUS_NONE){
                    DeactivateBonus((BONUS)pstPlayerRight->GetActivatedBonus(), PLAYER_RIGHT);
                    pstPlayerRight->BonusNone();
                    pstBonusBar1->SetFill(100);
                }

                ActivateBonus((BONUS)pstPlayerRight->ActivateBonus(), PLAYER_RIGHT);  
            }
	}
}

int Control::UpdateGame(const orxCLOCK_INFO *_pstClockInfo){
    int result = 1;	//GAME_STATUS::PLAYING
  
    pstBallStatus = (OBJECT_STATUS)pstBall->Update();
    
    if(pstPlayerLeft->IsHuman())
        pstPlayerLeftStatus = OBJECT_STATUS(pstPlayerLeft->Update());
    else{
        pstPlayerLeftStatus = OBJECT_STATUS(pstPlayerLeft->Update(pstBall));
        
        if(pstPlayerLeftStatus == ACTIVATE_BONUS){
            ActivateBonus((BONUS)pstPlayerLeft->ActivateBonus(), PLAYER_LEFT); 
        }
    }
    
    if(pstPlayerRight->IsHuman())
        pstPlayerRightStatus = OBJECT_STATUS(pstPlayerRight->Update());
    else{
        pstPlayerRightStatus = OBJECT_STATUS(pstPlayerRight->Update(pstBall));
        
        if(pstPlayerRightStatus == ACTIVATE_BONUS){
            ActivateBonus((BONUS)pstPlayerRight->ActivateBonus(), PLAYER_RIGHT);  
        }
    }

    //update movement
    pstPlayerRight->Movement(_pstClockInfo);
    pstPlayerLeft->Movement(_pstClockInfo);

    if(pstPlayerLeft->IsBonusTimerActive() || pstPlayerRight->IsBonusTimerActive()){
        //LEFT SIDE
        if(pstPlayerLeft->GetActivatedBonus() != BONUS_NONE){
            if(pstBonusBar1->Update(_pstClockInfo)==true){
                DeactivateBonus((BONUS)pstPlayerLeft->GetActivatedBonus(), PLAYER_LEFT);
                pstPlayerLeft->BonusNone();
                pstBonusBar1->SetFill(100);
            }
        }
        //RIGHT SIDE
        if(pstPlayerRight->GetActivatedBonus() != BONUS_NONE){
            if(pstBonusBar2->Update(_pstClockInfo)==true){
                DeactivateBonus((BONUS)pstPlayerRight->GetActivatedBonus(), PLAYER_RIGHT);
                pstPlayerRight->BonusNone();
                pstBonusBar2->SetFill(100);
            }
        }
    }
    
    //when the ball is out of the playground
    if(pstBallStatus == DEATH){
        bool playerLeftWin = false;
        bool playerRightWin = false;
        //which player is dead?
        if(pstPlayerLeftStatus == DEATH){
                //AI plus point
                //if you have change sides bonus activated then the point will be add to player who died 
                if(pstPlayerLeft->GetActivatedBonus() == CHANGE_SIDES || pstPlayerRight->GetActivatedBonus() == CHANGE_SIDES){
                    pstPlayerLeft->PlusPoint();
                    playerLeftWin = pstPointBar1->Add();
                }else{
                    pstPlayerRight->PlusPoint();
                    playerRightWin = pstPointBar2->Add();
                    
                }
        }else if(pstPlayerRightStatus == DEATH){
                //Player plus point
                if(pstPlayerRight->GetActivatedBonus() == CHANGE_SIDES || pstPlayerLeft->GetActivatedBonus() == CHANGE_SIDES){
                    pstPlayerRight->PlusPoint();
                    playerRightWin = pstPointBar2->Add();
                }else{
                    pstPlayerLeft->PlusPoint();
                    playerLeftWin = pstPointBar1->Add();
                }              
        }
        
        if(playerRightWin){
                bGameWinner = 1;		//right player won
                result = 3;                     //GAME_STATUS:END
        }else if(playerLeftWin){
                bGameWinner = -1;		//left player won
                result = 3;			//GAME_STATUS:END
        }

        //deactivate all bonuses
        if(Tools::GetObjectByName("Wall") != orxNULL)
            DeactivateBonus(PLAY_YOURSELF, PLAYER_LEFT);
        
        DeactivateBonus((BONUS)pstPlayerLeft->GetActivatedBonus(), PLAYER_LEFT);
        pstPlayerLeft->BonusNone();
        pstBonusBar1->SetFill(100);


        DeactivateBonus((BONUS)pstPlayerRight->GetActivatedBonus(), PLAYER_RIGHT);
        pstPlayerRight->BonusNone();
        pstBonusBar2->SetFill(100);


        //reload everything
        pstBorderLeft->RecoverBorder();
        pstBorderRight->RecoverBorder();
        pstBall->Disable();				
        pstPlayerLeft->Reload();			
        pstPlayerLeft->DisableSpawner();	
        pstPlayerRight->Reload();				
        pstPlayerRight->DisableSpawner();		

        if(bGameWinner == 0){
                //start the countdown after 2 sec
                orxClock_AddGlobalTimer(StartCountDown, 2.f, 1, orxNULL);
                result = 2; //GAME_STATUS::PAUSE
        }
    }  

    return result;
}

void Control::DetectedCollisions(const std::string recipient, const std::string sender){  
        //ball collide with players
        if(recipient.compare("BallParticle") == 0 && (sender.compare("Player1Paddle") == 0 || sender.compare("Player2Paddle") == 0 || sender.compare("AI1Paddle") == 0 || sender.compare("AI2Paddle") == 0)){
            pstBall->IncreaseSpeed();
            
            if(sender.compare("Player1Paddle") == 0 || sender.compare("AI2Paddle") == 0){
                pstBall->SetLastTouch(1);
            }else{
                pstBall->SetLastTouch(0);
            }
        //ball collide with borders
	}else if(recipient.compare("BallParticle") == 0 && (sender.compare("BorderLeft") == 0 || sender.compare("BorderRight") == 0)){
            pstBall->DecreaseSpeed();
        //ball collide with bonuses
	}else if(recipient.compare("BallParticle") == 0 && (sender.compare("BSlowMotion") == 0 || sender.compare("BChangeSides") == 0 || sender.compare("BInvisibility") == 0 || sender.compare("BHugePaddle") == 0 ||
                sender.compare("BSmallPaddle") == 0 || sender.compare("BMagneticPaddle") == 0 || sender.compare("BMegaStroke") == 0 || sender.compare("BRecover") == 0 || sender.compare("BPlayYourself") == 0))
        {
            int lastTouch = pstBall->GetLastTouch();
            //it depends on last touch who gain the bonus
            if(lastTouch != -1){
                orxSTRING bonusName = "";
                BONUS bonusType = BONUS_NONE;
                
                if(sender.compare("BSlowMotion") == 0){
                    bonusType = BALL_SLOW_MOTION;
                    bonusName = "BSlowMotion";
                }else if(sender.compare("BChangeSides") == 0){
                    bonusType = CHANGE_SIDES;
                    bonusName = "BChangeSides";
                    automaticBonusActivation = true;
                }else if(sender.compare("BInvisibility") == 0){
                    bonusType = INVISIBILITY;
                    bonusName = "BInvisibility";
                    automaticBonusActivation = true;
                }else if(sender.compare("BHugePaddle") == 0){
                    bonusType = HUGE_PADDLE;
                    bonusName = "BHugePaddle";
                }else if(sender.compare("BSmallPaddle") == 0){
                    bonusType = SMALL_PADDLE;
                    bonusName = "BSmallPaddle";
                    automaticBonusActivation = true;
                }else if(sender.compare("BMagneticPaddle") == 0){
                    bonusType = MAGNETIC_PADDLE;
                    bonusName = "BMagneticPaddle";
                }else if(sender.compare("BMegaStroke") == 0){
                    bonusType = MEGA_STROKE;
                    bonusName = "BMegaStroke";
                }else if(sender.compare("BRecover") == 0){
                    bonusType = RECOVER_BORDERS;
                    bonusName = "BRecover";
                }else if(sender.compare("BPlayYourself") == 0){
                    bonusType = PLAY_YOURSELF;
                    bonusName = "BPlayYourself";
                    automaticBonusActivation = true;
                }
                
                if(orxString_Compare(bonusName, "") != 0  && bonusType != BONUS_NONE){
                    //set the bonus to player
                    if(lastTouch == 0){
                        pstPlayerRight->SetBonus(bonusType, bonusName, !automaticBonusActivation);
                        //if automatic bonus activation is true then activate bonus
                        if(automaticBonusActivation == true){
                            //if some bonus is activated then deactivate it and activate the new one
                            if((BONUS)pstPlayerRight->GetActivatedBonus() != BONUS_NONE){
                                DeactivateBonus((BONUS)pstPlayerRight->GetActivatedBonus(), PLAYER_RIGHT);
                                pstPlayerRight->BonusNone();
                                pstBonusBar2->SetFill(100);
                            }
                            ActivateBonus((BONUS)pstPlayerRight->ActivateBonus(), PLAYER_RIGHT);
                        }
                        orxObject_SetLifeTime(bonuses[bonusType], orxFLOAT_0);
                    }else if(lastTouch == 1){
                        pstPlayerLeft->SetBonus(bonusType, bonusName, !automaticBonusActivation);
                        if(automaticBonusActivation == true){
                            if((BONUS)pstPlayerLeft->GetActivatedBonus() != BONUS_NONE){
                                DeactivateBonus((BONUS)pstPlayerLeft->GetActivatedBonus(), PLAYER_LEFT);
                                pstPlayerLeft->BonusNone();
                                pstBonusBar1->SetFill(100);
                            }
                            ActivateBonus((BONUS)pstPlayerLeft->ActivateBonus(), PLAYER_LEFT);
                        }
                        orxObject_SetLifeTime(bonuses[bonusType], orxFLOAT_0);
                    }
                    
                    automaticBonusActivation = false;                   
                }
            }
        //ball collide with wall
	}else if(recipient.compare("BallParticle") == 0 && sender.compare("Wall") == 0){
            pstBall->IncreaseSpeed(HIGH_POWER);
        }
}

void Control::UnDetectedCollisions(const std::string recipient, const std::string sender){
	if(recipient.compare("BallParticle") == 0 && sender.compare("DeathBorder") == 0){
		//destroy paddle
		orxOBJECT* temp;
                orxVECTOR position = pstBall->GetPosition(); 
		//destroy left player
		if(position.fX < 0){
			temp = pstPlayerLeft->GetPaddle();
			orxSpawner_Enable(orxOBJECT_GET_STRUCTURE(temp, SPAWNER), orxTRUE);
			orxObject_SetLifeTime(temp, 1.3f);
			orxObject_AddFX(temp, "PaddleFadeOut");
		//destroy right player
		}else if(position.fX > 0){
			temp = pstPlayerRight->GetPaddle();
			orxSpawner_Enable(orxOBJECT_GET_STRUCTURE(temp, SPAWNER), orxTRUE);
			orxObject_SetLifeTime(temp, 1.3f);
			orxObject_AddFX(temp, "PaddleFadeOut");	
		}
                
                orxObject_AddSound(temp, "PaddleDestroyedSound");
                pstBall->SetLastTouch(-1);
                temp = pstBall->GetBall();
		//ball disappear
		orxObject_AddFX(temp, "BallDeath");
		orxObject_SetLifeTime(temp, 2.0f);
	}
}

void Control::StartCountDown(const orxCLOCK_INFO *_pstClockInfo, void *_pstContext){
	orxObject_CreateFromConfig("BlackLayer");
	orxOBJECT* countdown = orxObject_CreateFromConfig("CountDown");
	//play animation
	orxObject_SetCurrentAnim(countdown, "CountDownAnim");
}

void Control::CreateBonus(const orxCLOCK_INFO* _pstClockInfo, void* _pstContext){
    int random = static_cast<int>(orxMath_GetRandomS32(0, 8));
   
    switch(random){
        case 0:
            //if bonus is already created then do nothing
            if(Tools::GetObjectByName("BSlowMotion") == orxNULL)
                bonuses[BALL_SLOW_MOTION] = orxObject_CreateFromConfig("BSlowMotion");
            break;
        case 1:
            if(Tools::GetObjectByName("BChangeSides") == orxNULL)
                bonuses[CHANGE_SIDES] = orxObject_CreateFromConfig("BChangeSides");
            break;
        case 2:
            if(Tools::GetObjectByName("BInvisibility") == orxNULL)
                bonuses[INVISIBILITY] = orxObject_CreateFromConfig("BInvisibility");
            break;
        case 3:
            if(Tools::GetObjectByName("BHugePaddle") == orxNULL)
                bonuses[HUGE_PADDLE] = orxObject_CreateFromConfig("BHugePaddle");
            break;
        case 4:
            if(Tools::GetObjectByName("BSmallPaddle") == orxNULL)
                bonuses[SMALL_PADDLE] = orxObject_CreateFromConfig("BSmallPaddle");
            break;
        case 5:
            /*if(Tools::GetObjectByName("BMagneticPaddle") == orxNULL)
                bonuses[MAGNETIC_PADDLE] = orxObject_CreateFromConfig("BMagneticPaddle");*/
            break;
        case 6:
            if(Tools::GetObjectByName("BMegaStroke") == orxNULL)
                bonuses[MEGA_STROKE] = orxObject_CreateFromConfig("BMegaStroke");
            break;
        case 7:
            if(Tools::GetObjectByName("BRecover") == orxNULL)
                bonuses[RECOVER_BORDERS] = orxObject_CreateFromConfig("BRecover");
            break;
        case 8:
            if(Tools::GetObjectByName("BPlayYourself") == orxNULL && Tools::GetObjectByName("Wall") == orxNULL)
                 bonuses[PLAY_YOURSELF] = orxObject_CreateFromConfig("BPlayYourself");
            break;
        default:
            break;
    }
        
    orxConfig_PushSection("BonusClock");
        float f = orxConfig_GetFloat("Frequency");
    orxConfig_PopSection();
    orxClock_SetTickSize(bonusClk, 1/f);
}

void Control::ActivateBonus(BONUS bonus, BONUS_INITIATOR ini){
    switch(bonus){
        case BALL_SLOW_MOTION:{
            pstBall->SlowMotion();
            if(ini == PLAYER_LEFT)
                pstPlayerRight->SlowMotion();
            else
                pstPlayerLeft->SlowMotion();
            break;
        }
        case CHANGE_SIDES:{
            orxCOLOR playerColor = *(pstPlayerLeft->GetColor());
            orxCOLOR aiColor = *(pstPlayerRight->GetColor());
            pstPlayerLeft->SetColor(&aiColor);
            pstPlayerRight->SetColor(&playerColor);
            
            if(ini == PLAYER_LEFT)
                pstPlayerLeft->SetNegativeBonus(true);
            else    
                pstPlayerRight->SetNegativeBonus(true);
            break;
        }
        case INVISIBILITY:{
            if(ini == PLAYER_LEFT){
                pstPlayerLeft->Invisible(true);
                pstPlayerLeft->SetNegativeBonus(true);
            }else{
                pstPlayerRight->Invisible(true);
                pstPlayerRight->SetNegativeBonus(true);
            }         
            break;
        }
        case HUGE_PADDLE:{
            if(ini == PLAYER_LEFT)
                pstPlayerLeft->Size(HUGE);
            else
                pstPlayerRight->Size(HUGE);
            break;
        }
        case SMALL_PADDLE:{
            if(ini == PLAYER_LEFT){
                pstPlayerLeft->Size(SMALL);
                pstPlayerLeft->SetNegativeBonus(true);
            }
            else{
                pstPlayerRight->Size(SMALL);
                pstPlayerRight->SetNegativeBonus(true);
            }
            break;
        }
        case MAGNETIC_PADDLE:{
            
            break;
        }
        case MEGA_STROKE:{
            pstBall->MegaStroke(true);
            
            if(ini == PLAYER_LEFT){
                pstPlayerLeft->BonusNone();
                pstBonusBar1->SetFill(100);
            }else{
                pstPlayerRight->BonusNone();
                pstBonusBar2->SetFill(100);
            }
            break;
        }
        case RECOVER_BORDERS:{
            if(ini == PLAYER_LEFT){
                pstBorderLeft->RecoverBorder();
                pstPlayerLeft->BonusNone();
                pstBonusBar1->SetFill(100);
            }else{
                pstBorderRight->RecoverBorder();
                pstPlayerRight->BonusNone();
                pstBonusBar2->SetFill(100);
            }
            break;
        }
        case PLAY_YOURSELF:{
            orxOBJECT* wall = Tools::GetObjectByName("Wall");
            if(wall == orxNULL)
                wall = orxObject_CreateFromConfig("Wall");
            
           //float sec = orxObject_GetLifeTime(wall);
            if(ini == PLAYER_LEFT){
                pstPlayerLeft->BonusNone();
                pstBonusBar1->SetFill(100);
                //pstPlayerLeft->SetNegativeBonus(true);
               // pstBonusBar1->SetSeconds(sec);
            }else{   
                pstPlayerRight->BonusNone();
                pstBonusBar2->SetFill(100);
               // pstPlayerRight->SetNegativeBonus(true);
                //pstBonusBar2->SetSeconds(sec);
            }
            
            break;
        }
        default:
            break;
    }
}
void Control::DeactivateBonus(BONUS bonus, BONUS_INITIATOR ini){
     switch(bonus){
        case BALL_SLOW_MOTION:{
            pstBall->NormalMotion();
            if(ini == PLAYER_LEFT)
                pstPlayerRight->NormalMotion();
            else
                pstPlayerLeft->NormalMotion();    
            break;
        }
        case CHANGE_SIDES:{
            orxCOLOR playerColor = *(pstPlayerLeft->GetColor());
            orxCOLOR aiColor = *(pstPlayerRight->GetColor());
            pstPlayerLeft->SetColor(&aiColor);
            pstPlayerRight->SetColor(&playerColor);
            
            if(ini == PLAYER_LEFT)
                pstPlayerLeft->SetNegativeBonus(false);
            else    
                pstPlayerRight->SetNegativeBonus(false);
            break;
        }
        case INVISIBILITY:{
            if(ini == PLAYER_LEFT){
                pstPlayerLeft->Invisible(false);
                pstPlayerLeft->SetNegativeBonus(false);
            }else{
                pstPlayerRight->Invisible(false);
                pstPlayerRight->SetNegativeBonus(false);
            }  
            
            break;
        }
        case HUGE_PADDLE:{
            if(ini == PLAYER_LEFT)
                pstPlayerLeft->Size(NORMAL);
            else
                pstPlayerRight->Size(NORMAL);
            break;
        }
        case SMALL_PADDLE:{
            if(ini == PLAYER_LEFT){
                pstPlayerLeft->Size(NORMAL);
                pstPlayerLeft->SetNegativeBonus(false);
            }
            else{
                pstPlayerRight->Size(NORMAL);
                pstPlayerRight->SetNegativeBonus(false);
            }
            break;
        }
        case MAGNETIC_PADDLE:{
            
            break;
        }
        case MEGA_STROKE:{
            pstBall->MegaStroke(false);
            break;
        }
        case RECOVER_BORDERS:{
            break;
        }
        case PLAY_YOURSELF:{
            orxOBJECT* wall = Tools::GetObjectByName("Wall");
            if(wall != orxNULL)
                orxObject_SetLifeTime(wall, orxFLOAT_0);
            break;
        }
        default:
            break;
    }
}

void Control::EndCountDown(const orxEVENT *_pstEvent){
	pstBall->Enable();
	pstBall->Reload();
	pstBallStatus = NOTHING;
	orxObject_SetLifeTime(orxOBJECT(_pstEvent->hRecipient), orxFLOAT_0);
	orxObject_SetLifeTime(Tools::GetObjectByName("BlackLayer"), orxFLOAT_0);	
}
