#ifndef _PADDLE_H
#define _PADDLE_H

#include "orx.h"
#include "Ball.h"
#include <string>
#include <iostream>	

//paddle sizes
#define HUGE 1.9f
#define NORMAL 1.0f
#define SMALL 0.5f

class Paddle{
protected:
	orxOBJECT*	oPaddleObject;          
        orxOBJECT*      oBonusObject;           
        orxOBJECT*      oIconBonusObject;
	orxVECTOR	vPaddlePos;		
        orxVECTOR       vBonusPos;              
	float		fAngle;			
	int		iRadius;		
        int             iSide;                  // left, right
	int		iDirection;		
        int             iBonus;                 //0->8 = bonuses, 9 = BONUS_NONE
        int             iBonusActivated;        
        bool            bBonusTimerActivated;   
        bool            bNegativeBonus;
        const orxCHAR*  sBonusName;             
	float		fSpeed;			
	float		fMaxSpeed;		
	int		iPoints;		
        bool            bHuman;

	const orxCHAR*  sName;                   
        
        orxSOUND*       sMovement;

public:
	Paddle();
	~Paddle();

	virtual orxSTATUS	Init(const orxCHAR* key) = 0;
	
	void				Movement(const orxCLOCK_INFO *_pstClockInfo);
	int				PlusPoint();
	void				Reload();
	virtual int			Update() {return 0;}
	virtual int			Update(Ball *) {return 0;}
        
        int                             ActivateBonus();
        void                            NormalMotion();
        void                            SlowMotion();
        void                            Invisible(bool enable);
        void                            Size(float size);

	void				Enable();
	void				Disable();

	void				DisableSpawner();
	
        void                            SetColor(orxCOLOR* color);
        void                            SetNegativeBonus(bool negative){ bNegativeBonus = negative;};
	void				SetDirection(int value);
        void                            SetBonus(int bonus, orxCHAR* name, bool show);
	void				SetOrientation(int value){ iRadius = 320*value;};	
	void				SetSpeed(float value){ fSpeed = value;};
        void                            BonusNone();
	
        orxCOLOR*                       GetColor();
        bool                            IsHuman(){ return bHuman;};
        bool                            IsBonusNegative(){ return bNegativeBonus;};
        bool                            IsBonusTimerActive(){ return bBonusTimerActivated;};
	int				GetDirection(){ return iDirection;};        
        int                             GetActivatedBonus(){ return iBonusActivated;};
	float				GetSpeed(){ return fSpeed;};
	int				GetPoints(){ return iPoints;};
	std::string			GetName(){ return sName;};
	orxOBJECT*			GetPaddle(){ return oPaddleObject;};
};

#endif
