
#include "Player.h"

Player::Player(const orxCHAR* key){
	Init(key);
}

Player::~Player(){
}

orxSTATUS Player::Init(const orxCHAR* key){
	this->oPaddleObject = orxObject_CreateFromConfig(key);
	if(this->oPaddleObject == orxNULL){
		orxLOG("Init()-<%s> nenalezen!", key);
		return orxSTATUS_FAILURE;
	}

	orxConfig_PushSection(key);
                this->iSide = static_cast<int>(orxConfig_GetFloat("Orientation"));
		this->fMaxSpeed = orxConfig_GetFloat("MaximalSpeed");
		this->iRadius = static_cast<int>(320*iSide);               
	orxConfig_PopSection();
        
        if(iSide == -1)
                this->vBonusPos.fX = -507.f;
        else
                this->vBonusPos.fX = 429.f;
        
	this->vBonusPos.fY = -115.f;

	orxSpawner_Enable(orxOBJECT_GET_STRUCTURE(oPaddleObject, SPAWNER), false);

	this->sName = orxObject_GetName(this->oPaddleObject);
        
        this->bHuman = true;

	return orxSTATUS_SUCCESS;
}

int Player::Update(){
	float lifetime = orxObject_GetLifeTime(oPaddleObject);
	if(lifetime < 1.0f && lifetime > 0.f){
		return 1; //return OBJECT_STATUS::DEATH
	}
	return 2; //return OBJECT_STATUS::NOTHING
}
