/* 
 * File:   TimeBar.h
 * Author: Reemon
 *
 * Created on 29. duben 2012, 15:20
 */

#ifndef TIMEBAR_H
#define	TIMEBAR_H

#include "orx.h"

class TimeBar {
public:
    TimeBar(orxVECTOR bg_position, orxVECTOR line_position, orxCOLOR color, orxOBJECT* bg, float scalex, float scaley, float seconds, bool charge = true);
    TimeBar(orxVECTOR bg_position, orxVECTOR line_position, orxCOLOR color, orxOBJECT* bg, float scalex, float scaley, int parts, bool charge = true);
    TimeBar(const TimeBar& orig);
    virtual ~TimeBar();
    
    void SetSeconds(float seconds);
    void SetFill(float percentage);
    bool Add();
    bool Update(const orxCLOCK_INFO *_pstClockInfo);
private:
    orxOBJECT* _timeLine;
    orxOBJECT* _background;
    
    float _discharge;
    float _time;
    float _currentTime;
    float _width;
    float _height;
    float _delay;
    bool _charge;
};

#endif	/* TIMEBAR_H */

